.\"	$OpenBSD: truncate.2,v 1.14 2013/04/08 19:49:55 guenther Exp $
.\"	$NetBSD: truncate.2,v 1.7 1995/02/27 12:39:00 cgd Exp $
.\"
.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)truncate.2	8.1 (Berkeley) 6/4/93
.\"
.Dd $Mdocdate: April 8 2013 $
.Dt TRUNCATE 2
.Os
.Sh NAME
.Nm truncate ,
.Nm ftruncate
.Nd truncate or extend a file to a specified length
.Sh SYNOPSIS
.Fd #include <unistd.h>
.Ft int
.Fn truncate "const char *path" "off_t length"
.Ft int
.Fn ftruncate "int fd" "off_t length"
.Sh DESCRIPTION
.Fn truncate
causes the file named by
.Fa path
or referenced by
.Fa fd
to be truncated or extended to
.Fa length
bytes in size.
If the file was larger than this size, the extra data is lost.
If the file was smaller than this size, it will be extended as if by
writing bytes with the value zero.
With
.Fn ftruncate ,
the file must be open for writing.
.Sh RETURN VALUES
A value of 0 is returned if the call succeeds.
If the call fails a \-1 is returned, and the global variable
.Va errno
specifies the error.
.Sh ERRORS
.Fn truncate
and
.Fn ftruncate
will succeed unless:
.Bl -tag -width Er
.It Bq Er EINVAL
The
.Fa length
is a negative value.
.It Bq Er EIO
An I/O error occurred updating the inode.
.El
.Pp
In addition,
.Fn truncate
may return the following errors:
.Bl -tag -width Er
.It Bq Er ENOTDIR
A component of the path prefix is not a directory.
.It Bq Er ENAMETOOLONG
A component of a pathname exceeded
.Dv {NAME_MAX}
characters, or an entire path name exceeded
.Dv {PATH_MAX}
characters.
.It Bq Er ENOENT
The named file does not exist.
.It Bq Er EACCES
Search permission is denied for a component of the path prefix.
.It Bq Er EACCES
The named file is not writable by the user.
.It Bq Er ELOOP
Too many symbolic links were encountered in translating the pathname.
.It Bq Er EISDIR
The named file is a directory.
.It Bq Er EROFS
The named file resides on a read-only file system.
.It Bq Er ETXTBSY
The file is a pure procedure (shared text) file that is being executed.
.It Bq Er EFAULT
.Fa path
points outside the process's allocated address space.
.El
.Pp
.Fn ftruncate
may return the following errors:
.Bl -tag -width Er
.It Bq Er EBADF
The
.Fa fd
is not a valid descriptor.
.It Bq Er EINVAL
The
.Fa fd
references a socket, not a file.
.It Bq Er EINVAL
The
.Fa fd
is not open for writing.
.El
.Sh SEE ALSO
.Xr open 2
.Sh STANDARDS
The
.Fn truncate
and
.Fn ftruncate
functions conform to
.St -p1003.1-2008 .
.Sh HISTORY
The
.Fn truncate
and
.Fn ftruncate
function calls appeared in
.Bx 4.2 .
.Sh BUGS
These calls should be generalized to allow ranges of bytes in a file
to be discarded.
.Pp
Use of
.Fn truncate
to extend a file is not portable.
